with GNATCOM.Dispinterface;

package MSHTML.IHTMLControlRange_Interface is

   type IHTMLControlRange_Type is
     new GNATCOM.Dispinterface.Dispinterface_Type with null record;

   procedure Initialize (This : in out IHTMLControlRange_Type);

   function Pointer (This : IHTMLControlRange_Type)
     return Pointer_To_IHTMLControlRange;

   procedure Attach (This    : in out IHTMLControlRange_Type;
                     Pointer : in     Pointer_To_IHTMLControlRange);

   procedure uselect
     (This : IHTMLControlRange_Type);

   procedure add
     (This : IHTMLControlRange_Type;
      item : Pointer_To_IHTMLControlElement);

   procedure remove
     (This  : IHTMLControlRange_Type;
      index : Interfaces.C.long);

   function item
     (This  : IHTMLControlRange_Type;
      index : Interfaces.C.long)
     return Pointer_To_IHTMLElement;

   procedure scrollIntoView
     (This        : IHTMLControlRange_Type;
      varargStart : GNATCOM.Types.VARIANT  := GNATCOM.Types.VARIANT_MISSING;
      Free        : Boolean := True);

   function queryCommandSupported
     (This  : IHTMLControlRange_Type;
      cmdID : GNATCOM.Types.BSTR;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT_BOOL;

   function queryCommandEnabled
     (This  : IHTMLControlRange_Type;
      cmdID : GNATCOM.Types.BSTR;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT_BOOL;

   function queryCommandState
     (This  : IHTMLControlRange_Type;
      cmdID : GNATCOM.Types.BSTR;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT_BOOL;

   function queryCommandIndeterm
     (This  : IHTMLControlRange_Type;
      cmdID : GNATCOM.Types.BSTR;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT_BOOL;

   function queryCommandText
     (This     : IHTMLControlRange_Type;
      cmdID    : GNATCOM.Types.BSTR;
      Free     : Boolean := True)
     return GNATCOM.Types.BSTR;

   function queryCommandValue
     (This      : IHTMLControlRange_Type;
      cmdID     : GNATCOM.Types.BSTR;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function execCommand
     (This   : IHTMLControlRange_Type;
      cmdID  : GNATCOM.Types.BSTR;
      showUI : GNATCOM.Types.VARIANT_BOOL;
      value  : GNATCOM.Types.VARIANT  := GNATCOM.Types.VARIANT_MISSING;
      Free   : Boolean := True)
     return GNATCOM.Types.VARIANT_BOOL;

   function execCommandShowHelp
     (This  : IHTMLControlRange_Type;
      cmdID : GNATCOM.Types.BSTR;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT_BOOL;

   function commonParentElement
     (This   : IHTMLControlRange_Type)
     return Pointer_To_IHTMLElement;

   function Get_length
     (This : IHTMLControlRange_Type)
     return Interfaces.C.long;

end MSHTML.IHTMLControlRange_Interface;

